<template>
  <div style="width:100%;height:100%" class="gravity_box">
      <span ref="span" class="showTxtSpan"></span>
    <div class="gravity_bg" ref="gravity_bg">
      <div class="L_box">
        <img ref="L_line" class="L_line" src="../../assets/images/gravity/L/l-line.png" alt>
        <img ref="L_star1" class="L_star1" src="../../assets/images/gravity/L/l-star1.png" alt>
        <img ref="L_star2" class="L_star2" src="../../assets/images/gravity/L/l-star2.png" alt>
        <img ref="L_text" class="L_text" src="../../assets/images/gravity/L/l-text.png" alt>
        <img
          @click="goStart()"
          ref="L_btn"
          class="L_btn"
          src="../../assets/images/gravity/btn.png"
          alt
        >
      </div>
      <div class="I_box">
        <img class="I_line" ref="I_line" src="../../assets/images/gravity/I/i-line.png" alt>
        <img ref="I_star1" class="I_star1" src="../../assets/images/gravity/I/i-star1.png" alt>
        <img ref="I_star2" class="I_star2" src="../../assets/images/gravity/I/i-star2.png" alt>
        <img class="I_text" ref="I_text" src="../../assets/images/gravity/I/i-text.png" alt>
        <img
          @click="goStart()"
          ref="I_btn"
          class="I_btn"
          src="../../assets/images/gravity/btn.png"
          alt
        >
      </div>
      <div class="P_box">
        <img ref="P_line" class="P_line" src="../../assets/images/gravity/P/p-line.png" alt>
        <img ref="P_star1" class="P_star1" src="../../assets/images/gravity/P/p-star1.png" alt>
        <img ref="P_star2" class="P_star2" src="../../assets/images/gravity/P/p-star2.png" alt>
        <img ref="P_text" class="P_text" src="../../assets/images/gravity/P/p-text.png" alt>
        <img
          @click="goStart()"
          ref="P_btn"
          class="P_btn"
          src="../../assets/images/gravity/btn.png"
          alt
        >
      </div>
      <div class="S_box">
        <img ref="S_line" class="S_line" src="../../assets/images/gravity/S/s-line.png" alt>
        <img ref="S_star1" class="S_star1" src="../../assets/images/gravity/S/s-star1.png" alt>
        <img ref="S_star2" class="S_star2" src="../../assets/images/gravity/S/s-star2.png" alt>
        <img ref="S_text" class="S_text" src="../../assets/images/gravity/S/s-text.png" alt>
        <img
          @click="goStart()"
          ref="S_btn"
          class="S_btn"
          src="../../assets/images/gravity/btn.png"
          alt
        >
      </div>
      <div class="A_box">
        <img ref="A_line" class="A_line" src="../../assets/images/gravity/A/a-line.png" alt>
        <img ref="A_star1" class="A_star1" src="../../assets/images/gravity/A/a-star1.png" alt>
        <img ref="A_star2" class="A_star2" src="../../assets/images/gravity/A/a-star2.png" alt>
        <img ref="A_text" class="A_text" src="../../assets/images/gravity/A/a-text.png" alt>
        <img
          @click="goStart()"
          ref="A_btn"
          class="A_btn"
          src="../../assets/images/gravity/btn.png"
          alt
        >
      </div>
      <div class="C_box">
        <img ref="C_line" class="C_line" src="../../assets/images/gravity/C/c-line.png" alt>
        <img ref="C_star1" class="C_star1" src="../../assets/images/gravity/C/c-star1.png" alt>
        <img ref="C_star2" class="C_star2" src="../../assets/images/gravity/C/c-star2.png" alt>
        <img ref="C_text" class="C_text" src="../../assets/images/gravity/C/c-text.png" alt>
        <img
          @click="goStart()"
          ref="C_btn"
          class="C_btn"
          src="../../assets/images/gravity/btn.png"
          alt
        >
      </div>
      <img
        ref="starImg"
        @load="load"
        class="starImg"
        src="../../assets/images/gravity/bg-none2.jpg"
        alt
      >
    </div>
  </div>
</template>

<script>
let currentX = 0,
  currentY = 0,
  currentZ = 0,
  lastX = 0,
  lastY = 0,
  lastZ = 0,
  leftPX = 0,
  topPX = 0;
let basePX = 6; //移动速度
let mo = function(e) {
  e.preventDefault();
};
// var vConsole = new VConsole();
export default {
  name: "Gravity2",
  data() {
    return {
      current: "Gravity"
    };
  },
  methods: {
    goStart() {
      // document.body.style.overflow = 'scroll'
      document.removeEventListener("touchmove", mo, { passive: false });
      // window.removeEventListener(
      //   "devicemotion",
      //   this.deviceMotionHandler,
      //   false
      // );
      if (this.orienterr) {
        this.orienterr.off();
      }
      this.current = "none";
      this.$router.replace("/starpoint/start");
    },
    //重力感应事件

    deviceMotionHandler(eventData) {
      if (this.current === "Gravity") {
        console.log(eventData);
        var acceleration = eventData.accelerationIncludingGravity;
        currentX = acceleration.x;
        currentY = acceleration.y;
        currentZ = acceleration.z;
        if (this._equipment == "android") {
          if (currentX >= 0.75 && leftPX <= 1875) {
            //左移
            leftPX = leftPX + basePX;
            // document.body.scrollLeft = leftPX;
          } else if (currentX <= -0.75 && leftPX >= 0) {
            //右移
            leftPX = leftPX - basePX;
            // document.body.scrollLeft = leftPX;
          } else if (currentY < 6 && topPX <= 533) {
            // 上移
            topPX = topPX + basePX;
            // document.body.scrollTop = topPX;
          } else if (currentY >= 6 && topPX >= 0) {
            // 下移
            topPX = topPX - basePX;
            document.body.scrollTop = topPX;
          } else {
            // document.body.scrollLeft = leftPX;
            // document.body.scrollTop = topPX;
          }
        } else {
          if (currentX >= 0.75 && leftPX >= 0) {
            //右移
            leftPX = leftPX - basePX;
            // document.body.scrollLeft = leftPX;
          } else if (currentX <= -0.75 && leftPX <= 1875) {
            //左移
            leftPX = leftPX + basePX;
            // document.body.scrollLeft = leftPX;
          } else if (currentY < -6 && topPX >= 0) {
            // 下移
            topPX = topPX - basePX;
            // document.body.scrollTop = topPX;
          } else if (currentY >= -6 && topPX <= 533) {
            // 上移
            topPX = topPX + basePX;
            // document.body.scrollTop = topPX;
          } else {
            // document.body.scrollLeft = leftPX;
            // document.body.scrollTop = topPX;
          }
        }
        this.moveGravity(leftPX, topPX);
        // this.$refs.span.innerHTML = currentY

        if (leftPX >= 5 && leftPX <= 430 && topPX <= 220) {
          // l星位置
          this.$refs.L_star1.classList.add("fadeIn");
          this.$refs.L_star2.classList.add("fadeIn_1");
          this.$refs.L_line.classList.add("fadeIn_2");
          this.$refs.L_text.classList.add("fadeIn_3");
          this.$refs.L_btn.classList.add("fadeIn_4");
        } else if (leftPX >= 600 && leftPX <= 1200 && topPX <= 220) {
          //i星位置
          this.$refs.I_star1.classList.add("fadeIn");
          this.$refs.I_star2.classList.add("fadeIn_1");
          this.$refs.I_line.classList.add("fadeIn_2");
          this.$refs.I_text.classList.add("fadeIn_3");
          this.$refs.I_btn.classList.add("fadeIn_4");
        } else if (leftPX > 1200 && leftPX <= 1700 && topPX <= 220) {
          //p星位置
          this.$refs.P_star1.classList.add("fadeIn");
          this.$refs.P_star2.classList.add("fadeIn_1");
          this.$refs.P_line.classList.add("fadeIn_2");
          this.$refs.P_text.classList.add("fadeIn_3");
          this.$refs.P_btn.classList.add("fadeIn_4");
        } else if (leftPX >= 270 && leftPX <= 810 && topPX > 220) {
          //S星位置
          this.$refs.S_star1.classList.add("fadeIn");
          this.$refs.S_star2.classList.add("fadeIn_1");
          this.$refs.S_line.classList.add("fadeIn_2");
          this.$refs.S_text.classList.add("fadeIn_3");
          this.$refs.S_btn.classList.add("fadeIn_4");
        } else if (leftPX >= 855 && leftPX <= 1375 && topPX > 220) {
          //aA星位置
          this.$refs.A_star1.classList.add("fadeIn");
          this.$refs.A_star2.classList.add("fadeIn_1");
          this.$refs.A_line.classList.add("fadeIn_2");
          this.$refs.A_text.classList.add("fadeIn_3");
          this.$refs.A_btn.classList.add("fadeIn_4");
        } else if (leftPX >= 1470 && topPX > 220) {
          //C星位置
          this.$refs.C_star1.classList.add("fadeIn");
          this.$refs.C_star2.classList.add("fadeIn_1");
          this.$refs.C_line.classList.add("fadeIn_2");
          this.$refs.C_text.classList.add("fadeIn_3");
          this.$refs.C_btn.classList.add("fadeIn_4");
        }
      }
    },
    fixed(n, m) {
      return Math.round(n / m) * m;
    },
    kfFilter(n) {
      return this.kf.filter(n);
    },
    moveGravity(x, y) {
      if (this.current === "Gravity") {
        // x = this.fixed(x,20);
        // y = this.fixed(y,10);
        // x = this.kfFilter(x);
        // y = this.kfFilter(y);
        if (x > 660) x = 660;
        if (x < -700) x = -700;
        if (y > this.MaxTop) y = this.MaxTop;
        if (y < this.MinTop) y = this.MinTop;
        this.$refs.span.innerHTML = x + '---' + y
        console.log([x, y]);
        $(".gravity_bg").css(
          "-webkit-transform",
          "translate3d(" + x + "px," + y + "px,0)"
        );
        //aA星位置
        if (x > -478 && x < 173) {
          this.$refs.A_star1.classList.add("fadeIn");
          this.$refs.A_star2.classList.add("fadeIn_1");
          this.$refs.A_line.classList.add("fadeIn_2");
          this.$refs.A_text.classList.add("fadeIn_3");
          this.$refs.A_btn.classList.add("fadeIn_4");
        } else {
          this.$refs.A_star1.classList.remove("fadeIn");
          this.$refs.A_star2.classList.remove("fadeIn_1");
          this.$refs.A_line.classList.remove("fadeIn_2");
          this.$refs.A_text.classList.remove("fadeIn_3");
          this.$refs.A_btn.classList.remove("fadeIn_4");
        }
        //i星位置
        if (x > -305 && x < 540) {
          this.$refs.I_star1.classList.add("fadeIn");
          this.$refs.I_star2.classList.add("fadeIn_1");
          this.$refs.I_line.classList.add("fadeIn_2");
          this.$refs.I_text.classList.add("fadeIn_3");
          this.$refs.I_btn.classList.add("fadeIn_4");
        } else {
          this.$refs.I_star1.classList.remove("fadeIn");
          this.$refs.I_star2.classList.remove("fadeIn_1");
          this.$refs.I_line.classList.remove("fadeIn_2");
          this.$refs.I_text.classList.remove("fadeIn_3");
          this.$refs.I_btn.classList.remove("fadeIn_4");
        }
        //s星位置
        if (x > 88 && x < 770) {
          this.$refs.S_star1.classList.add("fadeIn");
          this.$refs.S_star2.classList.add("fadeIn_1");
          this.$refs.S_line.classList.add("fadeIn_2");
          this.$refs.S_text.classList.add("fadeIn_3");
          this.$refs.S_btn.classList.add("fadeIn_4");
        } else {
          this.$refs.S_star1.classList.remove("fadeIn");
          this.$refs.S_star2.classList.remove("fadeIn_1");
          this.$refs.S_line.classList.remove("fadeIn_2");
          this.$refs.S_text.classList.remove("fadeIn_3");
          this.$refs.S_btn.classList.remove("fadeIn_4");
        }
        //6星位置
        if (x > 445 && x < 928) {
          this.$refs.L_star1.classList.add("fadeIn");
          this.$refs.L_star2.classList.add("fadeIn_1");
          this.$refs.L_line.classList.add("fadeIn_2");
          this.$refs.L_text.classList.add("fadeIn_3");
          this.$refs.L_btn.classList.add("fadeIn_4");
        } else {
          this.$refs.L_star1.classList.remove("fadeIn");
          this.$refs.L_star2.classList.remove("fadeIn_1");
          this.$refs.L_line.classList.remove("fadeIn_2");
          this.$refs.L_text.classList.remove("fadeIn_3");
          this.$refs.L_btn.classList.remove("fadeIn_4");
        }
        //p星位置
        if (x > -846 && x < -96) {
          this.$refs.P_star1.classList.add("fadeIn");
          this.$refs.P_star2.classList.add("fadeIn_1");
          this.$refs.P_line.classList.add("fadeIn_2");
          this.$refs.P_text.classList.add("fadeIn_3");
          this.$refs.P_btn.classList.add("fadeIn_4");
        } else {
          this.$refs.P_star1.classList.remove("fadeIn");
          this.$refs.P_star2.classList.remove("fadeIn_1");
          this.$refs.P_line.classList.remove("fadeIn_2");
          this.$refs.P_text.classList.remove("fadeIn_3");
          this.$refs.P_btn.classList.remove("fadeIn_4");
        }
        //c星位置
        if (x >= -850 && x < -420) {
          this.$refs.C_star1.classList.add("fadeIn");
          this.$refs.C_star2.classList.add("fadeIn_1");
          this.$refs.C_line.classList.add("fadeIn_2");
          this.$refs.C_text.classList.add("fadeIn_3");
          this.$refs.C_btn.classList.add("fadeIn_4");
        } else {
          this.$refs.C_star1.classList.remove("fadeIn");
          this.$refs.C_star2.classList.remove("fadeIn_1");
          this.$refs.C_line.classList.remove("fadeIn_2");
          this.$refs.C_text.classList.remove("fadeIn_3");
          this.$refs.C_btn.classList.remove("fadeIn_4");
        }
      }
    },
    onOrient(obj) {
      var a, b;
      a = obj.lon < 180 ? obj.lon : obj.lon - 360;
      b = obj.lat;

      a = a > 0 ? (a > 50 ? 50 : a) : a < -50 ? -50 : a;
      b = b > 0 ? (b > 50 ? 50 : b) : b < -50 ? -50 : b;
      this.moveGravity(a * 18, b * 6.3);
    },
    load() {
      // this.$dialog.loading.close();
      //重力感应
      var widTemp = $(window).width();
      var heiTemp = $(window).height();
      $(".gravity_bg").css({
        left: Math.floor((widTemp - 1800) / 2) + "px",
        top: Math.floor((heiTemp - 1200) / 2) + "px"
      });
      if (heiTemp > 1200) {
        this.MaxTop = 0;
        this.MinTop = 0;
      } else {
        this.MaxTop = Math.floor((heiTemp - 1200) / 2) * -1;
        this.MinTop = this.MaxTop * -1;
      }

      if (window.DeviceMotionEvent) {
        // window.addEventListener(
        //   "devicemotion",
        //   this.deviceMotionHandler,
        //   false
        // );
        this.kf = new KalmanFilter();
        this.orienterr = new Orienter();
        this.orienterr.onOrient = this.onOrient;
        console.log(this.orienterr);
        console.log(this.orienterr.on);
        this.orienterr.on();
      } else {
        alert("亲，你的设备不支持DeviceMotionEvent哦~");
      }
    }
  },
  mounted() {
    //禁止用户滑动页面
    // document.body.style.overflow='hidden';
    document.addEventListener("touchmove", mo, { passive: false }); //禁止页面滑动
    // this.$dialog.loading.open('图片正在加载中。。');
  }
};
</script>

<style scoped lang='less'>
.showTxtSpan{
      position: fixed;
      top: 0;
      left: 0;
      color: #ffffff;
      z-index: 5;
}
.gravity_box {
  width: 100%;
  height: 100%;
  position: relative;
  overflow: hidden;
  margin: 0 auto;
 
  .gravity_bg {
    width:  1800px;
    height: 1200px;
    position: absolute;
    // transition-duration: 0.16s;
     .starImg {
      position: absolute;
      width: 1800px;
      height: 1200px;
      top: 0;
      left: 0;
    }
    span {
      position: fixed;
      top: 0;
      left: 0;
      color: #ffffff;
      z-index: 5;
    }
    .L_box {
      transform: scale(0.7);
      position: absolute;
      top: 0;
      left: 120px;
      //  border: 2px  solid red;
      width: 362px;
      height: 559px;
      z-index: 2;
      display: flex;
      justify-content: center;
      align-items: center;
      img {
        position: absolute;
        opacity: 0;
      }
      .L_text {
        right: -10px;
      }
      .L_line {
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
      }
      .L_star1 {
        top: 30px;
        left: 25px;
      }
      .L_star2 {
        bottom: 30px;
      }
      .L_btn {
        bottom: 170px;
        width: 35%;
        left: 180px;
      }
    }
    .I_box {
      transform: scale(0.7);
      position: absolute;
      top: 0px;
      left: 600px;
      width: 362px;
      height: 559px;
      z-index: 2;
      display: flex;
      justify-content: center;
      align-items: center;
      //  border: 2px  solid red;
      img {
        position: absolute;
        opacity: 0;
      }

      .I_line {
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
      }
      .I_star1 {
        top: 52px;
        right: -15px;
      }
      .I_star2 {
        bottom: 40px;
        right: 125px;
      }
      .I_text {
        left: 0;
        top: 0;
      }
      .I_btn {
        top: 380px;
        width: 35%;
        right: 10px;
      }
    }
    .P_box {
      transform: scale(0.7);
      position: absolute;
      top: 0;
      left: 1100px;
      width: 362px;
      height: 559px;
      z-index: 2;
      display: flex;
      justify-content: center;
      // border: 2px  solid red;
      align-items: center;
      img {
        position: absolute;
        opacity: 0;
      }
      .P_line {
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
      }
      .P_star1 {
        top: 90px;
        left: 30px;
      }
      .P_star2 {
        right: 0;
        top: 50%;
        transform: translateY(-50%);
      }
      .P_text {
        bottom: -30px;
        left: 50%;
        transform: translateX(-50%);
      }
      .P_btn {
        top: 345px;
        width: 35%;
        right: 0;
      }
    }
    .S_box {
      transform: scale(0.7);
      position: absolute;
      top: 650px;
      left: 360px;
      width: 362px;
      height: 559px;
      z-index: 2;
      //  border: 2px  solid red;
      display: flex;
      justify-content: center;
      align-items: center;
      img {
        position: absolute;
        opacity: 0;
      }
      .S_line {
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
      }
      .S_star1 {
        top: 80px;
        right: 20px;
      }
      .S_star2 {
        bottom: 90px;
        right: 10px;
      }
      .S_text {
        bottom: -30px;
        left: 0;
      }
      .S_btn {
        bottom: 20px;
        width: 35%;
        right: -30px;
      }
    }
    .A_box {
      transform: scale(0.7);
      position: absolute;
      top: 650px;
      left: 860px;
      width: 362px;
      height: 559px;
      z-index: 2;
      display: flex;
      justify-content: center;
      align-items: center;
      // border: 2px  solid red;
      img {
        position: absolute;
        opacity: 0;
      }
      .A_line {
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
      }
      .A_star1 {
        top: 100px;
        left: 80px;
      }
      .A_star2 {
        bottom: 80px;
        right: 0;
      }
      .A_text {
        top: 0;
        right: -45px;
      }
      .A_btn {
        bottom: 40px;
        width: 35%;
        left: 50%;
        transform: translateX(-50%);
      }
    }
    .C_box {
      transform: scale(0.7);
      position: absolute;
      top: 650px;
      left: 1350px;
      width: 362px;
      height: 559px;
      z-index: 2;
      display: flex;
      justify-content: center;
      align-items: center;
      //  border: 2px  solid red;
      img {
        position: absolute;
        opacity: 0;
      }
      .C_star1 {
        transform: rotateZ(15deg);
        top: 94px;
        right: 35px;
      }
      .C_star2 {
        top: -53px;
        left: 40px;
        transform: rotateZ(15deg);
      }
      .C_text {
        right: 10px;
        top: 50%;
        transform: translateY(-50%);
      }
      .C_btn {
        width: 35%;
        bottom: 30px;
        left: 50%;
        transform: translateX(-50%);
      }
      .C_line {
        top: 0;
        left: 50%;
        transform: translateX(-50%) rotateZ(15deg);
      }
    }
  }
  
}
img {
  // animation:fadeIn 2s ease-in;
}

.fadeIn {
  animation: fadeIn 0.3s ease-in;
  animation-fill-mode: forwards;
}
.fadeIn_1 {
  animation: fadeIn 0.3s ease-in;
  animation-delay: 300ms;
  animation-fill-mode: forwards;
}
.fadeIn_2 {
  animation: fadeIn 0.3s ease-in;
  animation-delay: 600ms;
  animation-fill-mode: forwards;
}
.fadeIn_3 {
  animation: fadeIn 0.3s ease-in;
  animation-delay: 900ms;
  animation-fill-mode: forwards;
}
.fadeIn_4 {
  animation: fadeIn 0.3s ease-in;
  animation-delay: 1000ms;
  animation-fill-mode: forwards;
}
</style>